SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Tests'!
SystemOrganization addCategory: #'SqSync-Repository'!
SystemOrganization addCategory: #'SqSync-Tools'!

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'testing' stamp: 'mt 5/31/2010 12:13:09.093'!
isConnected
	"Fix socket bug under windows. Trigger a new receive operation to force status update in the plugin."
		
	self adjustInBuffer: (self socket
		receiveDataNonBlockingInto: inBuffer
		startingAt: inNextToWrite).
	
	^ self socket isConnected! !

!SyTcpSocket methodsFor: 'stream out' stamp: 'mt 5/30/2010 20:51:40.078'!
nextPutAll: aCollection
	"Overridden to be better testable with a normal stream. Use the optimized version #nextPutAllFlush:."
	
	^ self nextPutAllFlush: aCollection.! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:34:56.652'!
remoteAddressString

	^ NetNameResolver stringFromAddress: self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:36:39.6'!
remoteID

	^ self remoteAddressString, ':', self remotePort asString! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:13:53.535'!
forceStatusUpdate
	"Workaround for broken Windows socket plugin. Better use SyTcpSocket where #isConnected will not loose any bytes if available."

	self
		receiveDataNonBlockingInto: ' '
		startingAt: 1.! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:14:08.19'!
receiveDataNonBlockingInto: aStringOrByteArray startingAt: aNumber
	"To be used to fix the status bug under Windows."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size - aNumber + 1! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodWrapper class methodsFor: 'constants' stamp: 'SR 6/1/2010 10:07:33.141'!
notReplicatedSelectors

	^ {#=.}! !

!SyMethodWrapper class methodsFor: 'instance creation' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 6/1/2010 10:19:14.597'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	(SyMethodWrapper notReplicatedSelectors includes: (self selector)) ifFalse: [
		instrumentor ifNotNil: [
			instrumentor methodCalled: (self selector) on: anObject with: anArrayOfObjects resulting: result.
		].
	].
	^ result! !

Object subclass: #Person
	instanceVariableNames: 'givenName surname birthday address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'SR 5/15/2010 15:24:16.133'!
= anObject 

	^ (self givenName = anObject givenName) and: [self surname = anObject surname] and: [self birthday = anObject birthday] and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:51.253'!
address: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	address := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:27:34.621'!
birthday: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	birthday := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'classes methods processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor class methodsFor: 'support' stamp: 'rkrk 6/2/2010 12:44:51.953'!
cleanClass: class

	class methodDict values
		select: [:m | m isKindOf: MwMethodWrapper]
		thenDo: [:m | m instrumentor uninstrumentMethod: m].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:27:33.49'!
instrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self instrumentedClasses add: c.
			c selectors do: [:selector | self instrumentMethod: selector inClass: c ]
		]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:19:22.051'!
instrumentMethod: selector inClass: aClass

	| wrapper |
	(self isMethodInstrumented: selector inClass: aClass)  ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			wrapper := SyMethodWrapper on: selector inClass: aClass for: self.
			wrapper install.
		].
		(self instrumentedMethodsAt: aClass) add: selector.
	].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:23:09.66'!
instrumentedClasses

	^ classes ifNil: [classes := WeakSet new]! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:14.84'!
instrumentedMethods

	^ methods ifNil: [methods := WeakKeyDictionary new] ! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:05.214'!
instrumentedMethodsAt: aClass

	^ self instrumentedMethods at: aClass ifAbsentPut: [Set new]! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:39.999'!
isClassInstrumented: aClass

	^ self instrumentedClasses includes: aClass! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:48.289'!
isMethodInstrumented: selector inClass: aClass

	^ (self instrumentedMethods at: aClass ifAbsent: [Array empty]) includes: selector! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/17/2010 19:49:01.808'!
methodCalled: aSelector on: anObject with: anArrayOfObjects resulting: result

	self processor ifNotNil: [ self processor process: aSelector on: anObject with: anArrayOfObjects ].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'rkrk 6/2/2010 12:37:50.15'!
uninstrumentAllAndReset

	self instrumentedClasses do: [:ea | 
		self uninstrumentClass: ea].

	self instrumentedMethods keysAndValuesDo: [:aClass :selectors | 
		selectors do: [:s | 
			self uninstrumentMethod: (aClass >> s)]].

	self instrumentedMethods keysAndValuesRemove: [:k :v | true].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:37:17.823'!
uninstrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifTrue: [
		self instrumentedClasses remove: aClass.
		self instrumentedClasses remove: metaClass ifAbsent: []
	].
	
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'rkrk 6/2/2010 12:38:16.512'!
uninstrumentMethod: aCompiledMethod

	| registeredMethods aClass selector |
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.

	(self isMethodInstrumented: selector inClass: aClass)  ifTrue: [
		aCompiledMethod isMwMethodWrapper ifTrue: [	
			aCompiledMethod uninstall].
	
		registeredMethods := self instrumentedMethodsAt: aClass.
		registeredMethods remove: selector.
		registeredMethods ifEmpty: [self instrumentedMethods removeKey: aClass]].! !

Object subclass: #SyClient
	instanceVariableNames: 'socket repository protocolProcessor connectionProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/1/2010 10:56:01.045'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository.! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/1/2010 10:28:17.126'!
disconnect

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	socket close.
	
	"Clear method wrapper"
	repository clear.! !

!SyClient methodsFor: 'initialize-release' stamp: 'SR 6/1/2010 10:26:50.078'!
initialize

	super initialize.
	
	repository := SyRepository new shouldCreateApplyCommands: true.
	protocolProcessor := SySimpleProtocolProcessor new.! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SyClient methodsFor: 'orchestration' stamp: 'SR 6/1/2010 12:28:28.663'!
pvtUpdateRepository

	| command |
	command := protocolProcessor sendCommandBlocking: (SyListCommand new) on: socket.
	command executeWithResult: (self repository).! !

!SyClient methodsFor: 'initialize-release' stamp: 'SR 5/25/2010 17:58:36.143'!
release

	self isConnected ifTrue: [ self disconnect ].
	^ super release! !

!SyClient methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:26:06.706'!
repository

	^ repository! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/1/2010 14:44:57.737'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [ self disconnect ].
			(protocolProcessor processDataFrom: socket)
				ifFalse: [ self disconnect ]
		].
	] forkAt: 35.! !

!SyClient methodsFor: 'orchestration' stamp: 'SR 6/1/2010 10:59:26.746'!
update: anAspect with: aParameter

	(anAspect = #operation) ifTrue: [
		"Send SyApplyCommand to Protocol Processor"
		protocolProcessor sendCommandNonBlocking: aParameter on: socket.
		^ self.
	].

	(anAspect = #incomingCommand) ifTrue: [
		"Add command to Queue for later processing"
		^ self.
	].

	^ super update: anAspect with: aParameter! !

Object subclass: #SyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

SyCommand subclass: #SyApplyCommand
	instanceVariableNames: 'selector receiverUUID arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyApplyCommand class methodsFor: 'instance creation' stamp: 'SR 6/1/2010 10:21:25.37'!
receiver: aUUID selector: aSelector arguments: anArray

	^ SyApplyCommand new
		receiverUUID: aUUID;
		selector: aSelector;
		arguments: anArray;
		yourself.! !

!SyApplyCommand methodsFor: 'testing' stamp: 'SR 6/1/2010 09:57:39.714'!
= other

	^ self receiverUUID = other receiverUUID
		and: [self selector = other selector]
		and: [self arguments = other arguments]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:07.962'!
arguments

	^ arguments! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:04.672'!
arguments: anObject

	arguments := anObject! !

!SyApplyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 14:07:58.154'!
execute: aSyRepository

	^ true! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:01.619'!
receiverUUID

	^ receiverUUID! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:50.322'!
receiverUUID: anObject

	receiverUUID := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:57.086'!
selector

	^ selector! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:53.995'!
selector: anObject

	selector := anObject! !

!SyCommand methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 14:42:27.575'!
= anObject

	(self className = anObject className) ifFalse: [^ false].
	(self class instSize = anObject class instSize) ifFalse: [^ false].
	self instanceVariableValues withIndexDo: [ :value :index | ((anObject instVarAt: index) = value) ifFalse: [^ false]].
	
	^ true
	! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:48:12.618'!
execute: aSyRepository
	"Should implement the functionality of this command. For now only the repository is supplied. Should return false if connection should be closed. Otherwise true."
	
	self subclassResponsibility! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:55:28.135'!
executeWithResult: aSyRepository
	"If the command has a special meaning when it is executed on the sender side after being executed on the receiver side, this should be overridden. Parameter and results are the same as with #execute:"
	
	^ self execute: aSyRepository! !

SyCommand subclass: #SyListCommand
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyListCommand commentStamp: 'SR 6/1/2010 14:12:13.781' prior: 0!
Example command: {"type": "command", "command": {"instVars": [null], "class": "SyListCommand"}, "id": 0}!

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 14:07:37.286'!
execute: aSyRepository

	objects := aSyRepository metaRepository collect: [ :regObject | self pvtCreateRegObjectDictionary: regObject ].
	^ true! !

!SyListCommand methodsFor: 'execution' stamp: 'rkrk 6/2/2010 12:21:35.195'!
executeWithResult: aSyRepository

	objects do: [ :data |
		aSyRepository
			register: (self pvtCreateObject: (data at: #client))
			with: (UUID fromString: (data at: #uuidString))].
	^ true! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:45:57.765'!
objects

	^ objects! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:46:00.502'!
objects: anObject

	objects := anObject! !

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 12:21:23.716'!
pvtCreateObject: aDictionary

	| newObject |
	newObject := (Smalltalk at: ((aDictionary at: #class) asSymbol)) new.
	(aDictionary at: #instVars) withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
	^ newObject! !

!SyListCommand methodsFor: 'execution' stamp: 'rkrk 6/2/2010 11:47:02.818'!
pvtCreateRegObjectDictionary: aRegisteredObject

	^ Dictionary newFrom: {
		#uuidString -> (aRegisteredObject uuidString).
		#client ->  (Dictionary newFrom: {
			#class -> aRegisteredObject client className.
			#instVars -> aRegisteredObject client instanceVariableValues. }).
		}! !

SyCommand subclass: #SyQuitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyQuitCommand commentStamp: 'SR 6/1/2010 14:12:24.447' prior: 0!
Example command: {"type": "command", "command": {"instVars": [], "class": "SyQuitCommand"}, "id": 1}!

!SyQuitCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:48:26.021'!
execute: aSyRepository

	^ false! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/30/2010 21:39:10.819'!
processDataFrom: aStream senderID: aString
	"Hint: Expect stream API from SocketStream. Other Streams should work as well. Use the given ID to enable better content handling, e.g. for servers."
	
	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:46:29.438'!
sendCommandNonBlocking: anOperation on: aStream
	"Sends a command to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:47:04.728'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends a command back after it has been processed, does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'outgoingQueue outgoingQueueWorker incomingQueue currentCommandResultCache currentCommandResultSemaphore currentCommandResultId nextCommandID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor commentStamp: 'mt 5/31/2010 09:15:17.382' prior: 0!
Wire Protocol
---

1) All data is serialized or deserialized according to #serialize: and #deserialize:.

2) In a first version, JSON is used to serialize messages.

3) Messages are separated on the wire using a unique #messageEndToken.

4) Each message is dictionary with the following content:
	#channel -> aNumber
	#data -> aString
	
5) There is a #channel for commands, one for results of commands, and one for operations/updates.

6) For each command an increasing ID is sent along to verify the result on the command result channel:
	#id -> aNumber
	#command -> aString
	
7) The result of a command is as follows:
	#id -> aNumber
	#result -> aString
	
8) Update messages have to be deserialized in the #data field.!

!SySimpleProtocolProcessor class methodsFor: 'constants' stamp: 'SR 6/1/2010 12:24:19.963'!
messageEndToken
	"Return the token that will be transferred after the end of each message to allow the recipient of the message to recognize it fully. No message should contain this token."
	
	^ String crlf! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:21:01.153'!
deserialize: aStringOrStream

	^ Json readFrom: aStringOrStream readStream! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'SR 6/1/2010 12:04:35.726'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new. "To send outgoing commands."
	incomingQueue := SharedQueue new. "To schedule incoming commands."
	
	currentCommandResultSemaphore := Semaphore new. "To wait for command results."
	nextCommandID := 0.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:02.8'!
killOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifFalse: [ outgoingQueueWorker terminate ].! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/1/2010 13:59:39.663'!
nextCommand
	"Retrieve the next pending command from the incoming command queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:45:15.615'!
nextUpdate
	"Retrieve the next pending operation from the incoming update queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 14:48:51.266'!
processDataFrom: aStream
	"Depending on the channel, process the data"
	
	| message command rawMessage |
	rawMessage := aStream upToAll: SySimpleProtocolProcessor messageEndToken.
	rawMessage isEmpty ifTrue: [ ^ false ].
	
	message := self deserialize: rawMessage.
	command := self pvtCreateCommand: (message at: #command).

	((message at: #type) = 'command') ifTrue: [
		^ self
			pvtProcessCommand: command
			with: (message at: #id)
			from: aStream
	].
			
	((message at: #type) = 'result') ifTrue: [
		^ self
			pvtProcessCommandResult: command
			with: (message at: #id)
			from: aStream
	].
			
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:22:08.314'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifTrue: [
		outgoingQueueWorker := [ 
			[ outgoingQueue isEmpty] whileFalse: [ | opArray operationDict |
				opArray := outgoingQueue next.
				self
					pvtSendCommand: opArray second
					with: opArray first
					on: opArray third.
			].
		] fork.
	].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 6/1/2010 12:14:37.136'!
pvtCreateCommand: aDictionary

	| typeName variableData newObject |
	typeName := aDictionary at: #class.
	variableData := aDictionary at: #instVars.
	
	newObject := (Smalltalk at: (typeName asSymbol)) new.
	variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
	^ newObject! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 6/1/2010 12:13:25.299'!
pvtCreateCommandDictionary: aCommand

	^ Dictionary newFrom: {
		#class ->  aCommand className.
		#instVars -> aCommand instanceVariableValues. }! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:54:22.057'!
pvtNextCommandId

	| result |
	result := nextCommandID.
	nextCommandID := nextCommandID + 1.
	^ result! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:25.804'!
pvtProcessCommand: aCommand with: aCommandId from: aStream
	"Support commands."
	
	"Schedule incoming command to be processed by client or server application."
	incomingQueue nextPut: {
		aCommandId.
		aCommand.
		aStream}.
		
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:33.336'!
pvtProcessCommandResult: aCommand with: aCommandId from: aStream
	"Save the command result and signal."
	
	currentCommandResultId := aCommandId.
	currentCommandResultCache := aCommand.
	currentCommandResultSemaphore signal.

	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 14:02:12.462'!
pvtSendCommand: aCommand with: aCommandId on: aStream

	| data |
	data := self serialize: (Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'command'.
		#command -> (self pvtCreateCommandDictionary: aCommand)}).
	aStream nextPutAll: data, SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 14:02:29.335'!
sendCommandBlocking: aCommand on: aStream
	"Sends a command and returns its answer. Responsible for command-response-scheme."

	| commandId |
	commandId := self sendCommandNonBlocking: aCommand on: aStream.

	[currentCommandResultId = commandId] whileFalse: [ currentCommandResultSemaphore wait ].
	
	^ currentCommandResultCache.
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:54:33.906'!
sendCommandNonBlocking: anCommand on: aStream
	"Only use in client mode."

	| commandId |
	commandId := self pvtNextCommandId.
	
	outgoingQueue nextPut: {commandId. anCommand. aStream.}.
	self pvtCheckOutgoingQueueWorker.
	
	^ commandId
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 14:10:37.379'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends command result repeating the given ID so that the sender of the command can map the result correctly."

	| data |
	data := self serialize: (Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'result'.
		#command -> (self pvtCreateCommandDictionary: aCommand)}).
	
	aStream nextPutAll: data, SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:14:39.363'!
serialize: anObject

	^ Json render: anObject! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:53.286'!
client

	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:49.519'!
client: anObject

	client := anObject! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:43.328'!
uuid

	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:46.39'!
uuid: anObject

	uuid := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 11:54:26.291'!
uuidString

	^ self uuid asString! !

Object subclass: #SyRepository
	instanceVariableNames: 'objects instrumentor shouldCreateApplyCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 12:58:43.044'!
all

	^ objects collect: [:regObject | regObject client]! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:01.527'!
clear

	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SyRepository methodsFor: 'initialize-release' stamp: 'SR 6/1/2010 09:49:23.889'!
initialize

	super initialize.

	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.
	
	shouldCreateApplyCommands := false.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:41:38.775'!
isEmpty

	^ objects isEmpty! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:30:15.455'!
metaRepository

	^ objects! !

!SyRepository methodsFor: 'method wrappers' stamp: 'rkrk 6/2/2010 11:54:07.847'!
process: aSelector on: anObject with: anArray

	| registeredObject applyCommand |
	registeredObject := objects detect: [ :regObject | regObject client == anObject ] ifNone: [^ self].
	applyCommand := SyApplyCommand receiver: (registeredObject uuidString) selector: aSelector arguments: anArray.
	self changed: #operation with: applyCommand! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 13:25:18.746'!
regObjectFor: domainObject

	^ objects
		detect: [:regObj | regObj client == domainObject]
		ifNone: [^nil].! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 11:35:52.315'!
register: anObject

	^ self register: anObject with: UUID new! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 11:45:01.055'!
register: anObject with: uuid

	| registeredObject |
	(self all contains: [:o | o == anObject]) ifTrue: [Exception signal: 'Object already registered'].
	
	registeredObject := SyRegisteredObject new
		client: anObject;
		uuid: uuid;
		yourself.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	self shouldCreateApplyCommands ifTrue: [ 
		instrumentor instrumentClass: (anObject class)].
	
	^ registeredObject.! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 12:18:25.429'!
resolve: uuid

	^ (objects
		detect: [:regObj | regObj uuid = uuid]
		ifNone: [^nil]) client.! !

!SyRepository methodsFor: 'accessing' stamp: 'SR 6/1/2010 09:32:26.583'!
shouldCreateApplyCommands

	^ shouldCreateApplyCommands! !

!SyRepository methodsFor: 'accessing' stamp: 'SR 6/1/2010 09:45:38.946'!
shouldCreateApplyCommands: anObject

	shouldCreateApplyCommands := anObject.
	self updateMethodWrappers: anObject.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 14:14:09.691'!
size

	^ objects size! !

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 11:45:46.826'!
unregister: anObject

	objects removeAllSuchThat: [:regObject | regObject client == anObject].
	
	self shouldCreateApplyCommands ifTrue: [
		(objects contains: [:o | o client class == anObject class]) ifFalse: [
			instrumentor uninstrumentClass: (anObject class)]].! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/1/2010 09:45:23.992'!
updateMethodWrappers: aBoolean

	aBoolean ifTrue: [
		"enable Method Wrappers for all classes".
		self all do: [ :o | instrumentor instrumentClass: (o class) ].
		
	] ifFalse: [
		"disable Method Wrappers for all classes."
		instrumentor uninstrumentAllAndReset.
	]! !

Object subclass: #SyServer
	instanceVariableNames: 'tcpServer repository mainProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SyServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SyServer methodsFor: 'initialize-release' stamp: 'SR 6/1/2010 10:29:10.526'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	tcpServer protocolProcessor: SySimpleProtocolProcessor new.
	
	repository := SyRepository new.
	
	self startMainProcess.! !

!SyServer methodsFor: 'command handling' stamp: 'SR 6/1/2010 13:54:20.386'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array commandId command senderStream |
	array := tcpServer protocolProcessor nextCommand.

	commandId := array first.
	command := array second.
	senderStream := array third.
	
	(command execute: (self repository))
		ifTrue: [	tcpServer protocolProcessor
					sendCommandResult: command
					with: commandId
					on: senderStream ]
		ifFalse: [ senderStream close ].! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 5/31/2010 11:07:00.071'!
release

	mainProcess terminate.
	self stop.
	
	super release.! !

!SyServer methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:57.017'!
repository

	^ repository! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:30.576'!
start

	tcpServer listenOn: self class defaultPort.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:20:45.756'!
startMainProcess
	"This process triggers the continous work of the server."
	
	mainProcess := [
		[self processIncomingCommands] repeat.
	] fork.! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:34.193'!
stop

	tcpServer close.! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 6/2/2010 11:28:04.239'!
close

	"Closing listen part"
	listenProcess ifNotNilDo: [:p | p terminate].
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/29/2010 12:32:13.073'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'rkrk 5/26/2010 15:41:28.56'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/31/2010 08:40:06.698'!
socketForID: senderID
	"Return the stream corresponding to the given ID."

	^ self connections
		detect: [:con | con remoteID = senderID]
		ifNone: []! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/1/2010 14:45:25.751'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [Processor activeProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket) ifFalse: [Processor activeProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/31/2010 08:01:17.378'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket isValid ifTrue: [listenSocket closeAndDestroy].
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

TestCase subclass: #SyClientTests
	instanceVariableNames: 'server o1 o2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTests class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 14:41:32.817'!
defaultPort

	^ 22701! !

!SyClientTests methodsFor: 'running' stamp: 'rkrk 6/2/2010 12:58:53.547'!
setUp

	super setUp.
	server := SyServer new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.
	server repository
		register: o1;
		register: o2.
	server start.
		
	sut := SyClient new.! !

!SyClientTests methodsFor: 'running' stamp: 'rkrk 6/2/2010 12:55:01.96'!
tearDown

	super tearDown.
	sut disconnect.
	"sut release."
	
	server stop.
	server release.
	server repository clear.! !

!SyClientTests methodsFor: 'testing' stamp: 'SR 5/15/2010 14:52:42.972'!
test01ConnectDisconnect

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	sut disconnect.! !

!SyClientTests methodsFor: 'testing' stamp: 'SR 6/1/2010 14:13:50.351'!
test02GetObjects

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	
	self assert: (sut repository size = 2).
	self assert: (sut repository all contains: [:o| o = o1]).
	self assert: (sut repository all contains: [:o| o = o2]).
	
	
	sut disconnect.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/2/2010 13:24:47.531'!
test03ServerAppliesClientOperation

	| objClient uuid |
	"maybe this test should go somewhere else"
	sut connectToHostNamed: 'localhost' port: self class defaultPort.
	uuid := (server repository regObjectFor: o1) uuid.
	objClient := sut repository resolve: uuid.
	objClient givenName: 'Hans'.

	self assert: 'Hans' equals: o1 givenName.! !

TestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer tcpSocket openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/31/2010 17:45:07.581'!
connectTCPClientToServer

	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	openClientSockets add: tcpSocket.
	
	(Delay forMilliseconds: 100) wait.
	Processor yield.
	
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/31/2010 17:45:19.684'!
disconnectTCPClientsFromServer

	tcpSocket ifNotNil: [tcpSocket close. tcpSocket := nil].
	openClientSockets do: [:ea | ea close].
	
	(Delay forMilliseconds: 100) wait.
	Processor yield.! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:17'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 5/10/2010 11:39:41.976'!
startTcpServer

	tcpServer ifNil: [tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:40:31.018'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:28.164'!
test04TcpSocketConnection

	self
		startTcpServer;
		connectTCPClientToServer;
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:47.813'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 16:55'!
wait: seconds

	(Delay forSeconds: seconds) wait.! !

TestCase subclass: #SyRepositoryTests
	instanceVariableNames: 'sut o1 o2 applyCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 09:39:19.875'!
setUp

	super setUp.
	
	sut := SyRepository new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 09:55:08.924'!
tearDown

	sut shouldCreateApplyCommands: false.! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 09:42:02.101'!
test01UnRegisterObject

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	sut unregister: o1.
	self assert: sut isEmpty.! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 09:55:42.994'!
test02DoubleRegistration

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	
	self
		should: [sut register: o1]
		raise: Exception.
! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 09:50:08.107'!
test03UnWrapObject

	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut shouldCreateApplyCommands: false.
	sut register: o1.
	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut shouldCreateApplyCommands: true.
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut unregister: o1.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 10:22:58.388'!
test04ApplyCommandCreation

	sut shouldCreateApplyCommands: true.
	sut register: o1.
	sut addDependent: self.
	
	applyCommand := nil.
	o1 givenName: 'Peter'.
	self assert: applyCommand selector = 'givenName:'.! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 10:24:59.726'!
test05OperationStackTest

	"self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations isEmpty).
	o1 givenName: 'Test2'.
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations size = 1).
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations first selector = #givenName:)."! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'rkrk 6/2/2010 12:30:29.819'!
test06ServerReceivesAndAppliesOperation

	"self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations isEmpty).
	o1 givenName: 'Test2'.
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations size = 1).
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations first selector = #givenName:)."! !

!SyRepositoryTests methodsFor: 'as yet unclassified' stamp: 'SR 6/1/2010 10:22:24.996'!
update: anAspect with: aParameter

	(anAspect = #operation) ifTrue: [ applyCommand := aParameter ].
	super update: anAspect with: aParameter.! !

TestCase subclass: #SySimpleProtocolProcessorTest
	instanceVariableNames: 'sut o1 stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:10:42.257'!
clearStream

	stream := ReadWriteStream on: ''.! !

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:18:41.14'!
resetStream

	stream reset.! !

!SySimpleProtocolProcessorTest methodsFor: 'running' stamp: 'mt 5/30/2010 20:46:11.522'!
setUp

	super setUp.
	sut := SySimpleProtocolProcessor new.
	o1 := Dictionary newFrom: {
		#tag -> 'uuid'.
		#value -> UUID new asString}.
	self clearStream.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 5/30/2010 20:43:53.893'!
test01Serialization

	self assert: (sut deserialize: (sut serialize: o1)) = o1.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'SR 6/1/2010 14:45:11.72'!
test02SendingReceivingCommands

	| command process result nextCommand |

	command := SyQuitCommand new.
			
	process := [
		result := sut sendCommandBlocking: command on: stream
	] forkAt: 60.
	
	self resetStream.
	sut processDataFrom: stream.
	
	nextCommand := sut nextCommand.
	self assert: {0. command. stream.} equals: nextCommand.
	
	self clearStream.
	sut  sendCommandResult: (nextCommand second) with: (nextCommand first) on: stream.
	
	self resetStream.
	sut processDataFrom: stream.
	
	Processor yield. "Let the result variable be set."

	self
		assert: (nextCommand second) equals: result;
		assert: process isTerminated.! !

TestCase subclass: #SySocketBugTest
	instanceVariableNames: 's1 s2 s3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySocketBugTest methodsFor: 'running' stamp: 'rkrk 5/29/2010 11:56:47.535'!
tearDown

	super tearDown.
	s1 closeAndDestroy.
	s2 closeAndDestroy.
	s3 closeAndDestroy.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:17.802'!
test01AutoDisconnection

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	self
		assert: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 == s2.

	s2 closeAndDestroy.
	s1 forceStatusUpdate.
		
	self
		deny: s2 isConnected;
		deny: s1 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:23.284'!
test02AutoDisconnectionWithServer

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345 backlogSize: 4.
	s2 connectToHostNamed: 'localhost' port:  12345.
	s3 := s1 waitForAcceptFor: 5.
	s2 waitForConnectionFor: 5.
	
	self
		deny: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 isConnected.

	s2 closeAndDestroy.
	s3 forceStatusUpdate.
		
	self
		deny: s1 isConnected;
		deny: s2 isConnected;
		deny: s3 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 13:37:50.642'!
test03StreamWorkaround
	"Check whether the workaround discards no data unexpectedly."

	| stream1 stream2 |
	
	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	
	stream1 := SyTcpSocket on: s1.
	stream2 := SyTcpSocket on: s2.
	
	stream1 nextPutAll: 'Hello!!'.
	stream2 isConnected. "This contains the workaround."
	
	self assert: 'Hello' equals: (stream2 upToAll: '!!').
! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/31/2010 08:37:35.378'!
detect: aBlock ifNone: aNoneBlock

	^ self mutex critical: [super detect: aBlock ifNone: aNoneBlock]! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/30/2010 19:50:56.398'!
size

	^ self mutex critical: [super size]! !
